package com.ruoyi.learn.domain;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 答卷对象 learn_examinee
 * 
 * @author ruoyi
 * @date 2025-09-25
 */
public class LearnExaminee extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 答卷id */
    private Long examineeId;

    /** 学生id */
    @Excel(name = "学生id")
    private Long studentId;

    /** 试卷类型 */
    @Excel(name = "试卷类型")
    private Integer paperType;

    /** 试卷id */
    @Excel(name = "试卷id")
    private Long paperId;

    @Excel(name = "试卷标识")
    private String paperKey;

    @Excel(name = "试卷信息")
    private String paperInfo;

    @Excel(name = "做题时长")
    private Long duration;
    
    /** 开始时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "开始时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date beginTime;

    /** 结束时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "结束时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date endTime;

    /** ExamineeStatus */
    @Excel(name = "考卷状态 ExamineeStatus ")
    private Integer state;

    /** 分级 */
    @Excel(name = "分级")
    private String scoreLevel;

    /** 分值 */
    @Excel(name = "分值")
    private Integer score;

    /** 分率 */
    @Excel(name = "分率")
    private Integer scoreRate;

    /** 名次 */
    @Excel(name = "名次")
    private Long ranking;

    /** 年排名次 */
    @Excel(name = "年排名次")
    private Long gradeRanking;

    private String stats;

    @Excel(name = "错题总数")
    private Integer wrongCount;

    /** 选择题正确数 */
    @Excel(name = "选择题正确数")
    private Long chooseCount;

    /** 选择题总数 */
    @Excel(name = "选择题总数")
    private Long chooseTotal;

    /** 主观题正确数 */
    @Excel(name = "主观题正确数")
    private Long subjectiveCount;

    /** 主观题总数 */
    @Excel(name = "主观题总数")
    private Long subjectiveTotal;

    private Long subjectId;


    public Long getSubjectId() {
        return subjectId;
    }

    public void setSubjectId(Long subjectId) {
        this.subjectId = subjectId;
    }

    public void setExamineeId(Long examineeId)
    {
        this.examineeId = examineeId;
    }

    public Long getExamineeId() 
    {
        return examineeId;
    }

    public void setStudentId(Long studentId) 
    {
        this.studentId = studentId;
    }

    public Long getStudentId() 
    {
        return studentId;
    }

    public void setPaperType(Integer paperType)
    {
        this.paperType = paperType;
    }

    public Integer getPaperType()
    {
        return paperType;
    }

    public void setPaperId(Long paperId) 
    {
        this.paperId = paperId;
    }

    public Long getPaperId() 
    {
        return paperId;
    }

    public String getPaperKey() {
        return paperKey;
    }

    public void setPaperKey(String paperKey) {
        this.paperKey = paperKey;
    }

    public String getPaperInfo() {
        return paperInfo;
    }

    public void setPaperInfo(String paperInfo) {
        this.paperInfo = paperInfo;
    }

    public Long getDuration() {
        return duration;
    }

    public void setDuration(Long duration) {
        this.duration = duration;
    }

    public void setBeginTime(Date beginTime)
    {
        this.beginTime = beginTime;
    }

    public Date getBeginTime() 
    {
        return beginTime;
    }

    public void setEndTime(Date endTime) 
    {
        this.endTime = endTime;
    }

    public Date getEndTime() 
    {
        return endTime;
    }

    public void setState(Integer state)
    {
        this.state = state;
    }

    public Integer getState()
    {
        return state;
    }

    public String getStats() {
        return stats;
    }

    public void setStats(String stats) {
        this.stats = stats;
    }

    public Integer getWrongCount() {
        return wrongCount;
    }

    public void setWrongCount(Integer wrongCount) {
        this.wrongCount = wrongCount;
    }

    public void setScoreLevel(String scoreLevel)
    {
        this.scoreLevel = scoreLevel;
    }

    public String getScoreLevel() 
    {
        return scoreLevel;
    }

    public void setScore(Integer score)
    {
        this.score = score;
    }

    public Integer getScore()
    {
        return score;
    }

    public void setScoreRate(Integer scoreRate)
    {
        this.scoreRate = scoreRate;
    }

    public Integer getScoreRate()
    {
        return scoreRate;
    }

    public void setRanking(Long ranking) 
    {
        this.ranking = ranking;
    }

    public Long getRanking() 
    {
        return ranking;
    }

    public void setGradeRanking(Long gradeRanking) 
    {
        this.gradeRanking = gradeRanking;
    }

    public Long getGradeRanking() 
    {
        return gradeRanking;
    }

    public void setChooseCount(Long chooseCount) 
    {
        this.chooseCount = chooseCount;
    }

    public Long getChooseCount() 
    {
        return chooseCount;
    }

    public void setChooseTotal(Long chooseTotal) 
    {
        this.chooseTotal = chooseTotal;
    }

    public Long getChooseTotal() 
    {
        return chooseTotal;
    }

    public void setSubjectiveCount(Long subjectiveCount) 
    {
        this.subjectiveCount = subjectiveCount;
    }

    public Long getSubjectiveCount() 
    {
        return subjectiveCount;
    }

    public void setSubjectiveTotal(Long subjectiveTotal) 
    {
        this.subjectiveTotal = subjectiveTotal;
    }

    public Long getSubjectiveTotal() 
    {
        return subjectiveTotal;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("examineeId", getExamineeId())
            .append("studentId", getStudentId())
            .append("paperType", getPaperType())
            .append("paperId", getPaperId())
            .append("beginTime", getBeginTime())
            .append("endTime", getEndTime())
            .append("state", getState())
            .append("scoreLevel", getScoreLevel())
            .append("score", getScore())
            .append("scoreRate", getScoreRate())
            .append("ranking", getRanking())
            .append("gradeRanking", getGradeRanking())
            .append("chooseCount", getChooseCount())
            .append("chooseTotal", getChooseTotal())
            .append("subjectiveCount", getSubjectiveCount())
            .append("subjectiveTotal", getSubjectiveTotal())
            .append("createTime", getCreateTime())
            .append("updateTime", getUpdateTime())
            .toString();
    }
}
